/*                                                                                      
 *  confmgr3.h: Configuration utilities                                                 
 *
 *  Copyright (C) 2010- John Coppens (john@jcoppens.com)        
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 3 of
 *  the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *  
 *  You should have received a copy of the GNU Library General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  
 */

#ifndef CONFMGR3_H
#define CONFMGR3_H

#include <gtk/gtk.h>
				//
enum {	CDEF_NOVALUE,		//	l
	CDEF_ENTRY2STR,		//	l	char *
	CDEF_ENTRY2DBL,		//	l	double
	CDEF_ENTRY2INT,		//	l	int
	CDEF_CBBOX2STR,		//	l	char *
	CDEF_CBBOX2INT,		//	l	int
	CDEF_CBENTRY2STR,	//	l	char *
	CDEF_SPBTN2INT,		//	l	int
	CDEF_CBTN2CHAR,		//	l	char
	CDEF_CBTN2BIT,		//		int (aux indicates bit)
	CDEF_RBTN2CHAR,		//	l
	CDEF_LABEL2STR,		//	l	char *
	CDEF_LABEL2DBL,		//	l	double
	CDEF_LABEL2INT,		//	l	int
	CDEF_FONTBTN2STR,	//	l	char *
	CDEF_DATE2INT,
	CDEF_CHAR,
	CDEF_DOUBLE,
	CDEF_INT
};

typedef struct {
  char		*wdg_name;	// Widget name
  GtkWidget	*wdg; 		// Widget reference
  unsigned char	type;	        // Field type
  unsigned char	aux;		// Aux value (bitnr etc)
  char		*keyname;	// Name of GConf key
  gpointer	var;		// Pointer to variable
  gpointer	def;		// Default value (char* or int)
} conf_definition;

typedef GtkWidget *(*lookup_function)();

	// These are for use with Glade-3
void		confd_get_widgets_from_builder(GtkBuilder *builder, 
                        conf_definition *tbl);
void		confd_set_glade2_widgets(conf_definition *tbl,
			GtkWidget *ref,
                	lookup_function lookup_widget);

	// Transfer data to (or from) a variable to the actual widgets
void		confd_get_values_from_widgets(conf_definition *tbl);
void		confd_set_widgets_to_values(conf_definition *tbl);
void		confd_clear_widgets_to_defaults(conf_definition *tbl);

	// Load (or save) a configuration from disk
void		load_by_table(conf_definition *tbl, char *path);
int		save_by_table(conf_definition *tbl, char *path);

	// Set the selection of a combobox the entry corresponding to 'str'
void		set_combo_box_store_to_string(GtkComboBox *cbbox, char *str);

	// Load a combobox with a (NULL-terminated) list of strings
void		load_combo_box_with_strings(GtkComboBox *cbbox, char **str);

#endif
